const rp = require('request-promise')
const jar = rp.jar()

const requestOptions = {
  uri: 'https://comp.swisstennis.ch/advantage/servlet/MyTournamentList?Lang=D',
  // method: 'GET',
  jar,
  headers: {
    Host: 'comp.swisstennis.ch',
    'User-Agent': 'Mozilla/5.0 (X11; Linux x86_64; rv:52.0) Gecko/20100101 Firefox/52.0',
    Accept: 'text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8',
    'Accept-Language': 'de-CH,de;q=0.8,en-US;q=0.5,en;q=0.3',
    // 'Accept-Encoding': 'gzip, deflate, br',
    // Cookie: JSESSIONID=EE3CDACFFEBA200E8359F85E1C0DFB01; _ga=GA1.2.478228767.1500102081; _gid=GA1.2.1193701205.1500102081,
    Connection: 'keep-alive',
    'Upgrade-Insecure-Requests': '1',
    'Cache-Control': 'max-age=0'
  },
  resolveWithFullResponse: true
}

const loginOptions = {
  uri: 'https://comp.swisstennis.ch/advantage/servlet/Login',
  // method: 'POST',
  jar,
  form: {
    Lang: 'D',
    id: '105',
    pwd: 'S3589V',
    Tournament: ''
  },
  headers: {
    Host: 'comp.swisstennis.ch',
    'User-Agent': 'Mozilla/5.0 (X11; Linux x86_64; rv:52.0) Gecko/20100101 Firefox/52.0',
    Accept: 'text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8',
    'Accept-Language': 'de-CH,de;q=0.8,en-US;q=0.5,en;q=0.3',
    // 'Accept-Encoding': 'gzip, deflate, br',
    Referer: 'https://comp.swisstennis.ch/advantage/servlet/MyTournamentList?Lang=D',
    // Cookie: JSESSIONID=53BE225CCCAC5F8D1FDB9C126F3A737C; _ga=GA1.2.478228767.1500102081; _gid=GA1.2.1193701205.1500102081
    'Upgrade-Insecure-Requests': '1',
    Connection: 'keep-alive'
  }
}

const downloadOptions = {
  uri: 'https://comp.swisstennis.ch/advantage/servlet/MyTournamentList?Lang=D',
  // method: 'GET',
  jar,
  headers: {
    Host: 'comp.swisstennis.ch',
    'User-Agent': 'Mozilla/5.0 (X11; Linux x86_64; rv:52.0) Gecko/20100101 Firefox/52.0',
    Accept: 'text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8',
    'Accept-Language': 'de-CH,de;q=0.8,en-US;q=0.5,en;q=0.3',
    // 'Accept-Encoding': 'gzip, deflate, br',
    Referer: 'https://comp.swisstennis.ch/advantage/servlet/MyTournamentList?Lang=D',
    // Cookie: JSESSIONID=53BE225CCCAC5F8D1FDB9C126F3A737C; _ga=GA1.2.478228767.1500102081; _gid=GA1.2.1193701205.1500102081,
    // 'Upgrade-Insecure-Requests': '1',
    Connection: 'keep-alive'
  }
}

console.log('Requesting login page.')
rp.get(requestOptions).then(body => {
  console.log(body)
  console.log(jar)
  console.log('Requesting login.')
  rp.post(loginOptions).then(body => {
    console.log('in then')
    console.log(body)
    console.log(jar)
    console.log('Requesting tournament list.')
    rp.get(downloadOptions).then(body => {
      console.log(body)
      console.log(jar)
    })
  }).catch(body => {
    console.log('in catch')
    console.log(body)
    console.log(jar)
    console.log('Requesting tournament list.')
    rp.get(downloadOptions).then(body => {
      console.log(body)
      console.log(jar)
    })
  })
})
