import React from 'react'
import PlayerActions from './PlayerActions'
import PlayerTable from './PlayerTable'
import PlayerFilter from './PlayerFilter'

class PlayerList extends React.Component {
  render () {
    const { state, actions } = this.props
    return (
      <div>
        <h1>Spielerliste</h1>
        <PlayerActions state={state} actions={actions} />
        <PlayerFilter state={state} actions={actions} />
        <PlayerTable state={state} actions={actions} />
      </div>
    )
  }
}

export default PlayerList
